import type * as Monaco from 'monaco-editor';
import type { editor, Range as R } from 'monaco-editor';
import type { EditorView } from '@codemirror/view';
import type { AST } from 'wikiparser-node';
declare type Tree = Promise<AST> & {
    docChanged?: boolean;
};
export declare const trees: WeakMap<EditorView | editor.ITextModel, Tree>;
/**
 * 获取语法树
 * @param model 键
 * @param stage 解析阶段，现仅用于CodeMirror
 */
export declare const getTree: (model: editor.ITextModel | EditorView, stage?: number) => Tree;
export declare const fromPositions: (monaco: typeof Monaco, model: editor.ITextModel, ref: [number, number]) => R;
export {};
